%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%                  funzione principale6 - esercizio 6              %
%           Esercitazione in laboratorio del 20/2/2009             %
%******************************************************************%
%
%   function principale6(comandi)
%

function principale6(comandi)

%calcolo gli spostamenti del robot
posizione=calcolaspostamento(comandi)

%visualizzo la posizione attuale del robot
visualizza(posizione)

% invoco la gohome per calcolare i comandi per tornare all'origine
home=gohome(posizione)

%aggiorno la matrice comandi con i comandi per tornare all'origine
comandi=[comandi ; home];

%salvo i comandi in un nuovo file
salvacomandi(comandi,'comandi2.txt');

%--------------------------------- Fine principale ---------------------

%% function posizione=calcolaspostamento(comandi)
% La funzione valuta la matrice comandi, contentente la sequenza di comandi
% forniti al robot, e ne valuta la posizione, vettore (2x1). L'elemento
% contiene il punto ove si trova, con coordinate (x,y) rispetto al punto di
% partenza

function posizione=calcolaspostamento(comandi)

%Nota: si suppone di importare tutti i dati del file comandi.txt, usando
%IW, in una matrice di nome 'comandi'

%seleziono le due colonne della matrice, separando i dati relativi aklla
%direzione e a quelli della distanza percorsa
direzione=comandi(:,1);
metri=comandi(:,2);

%Inizializzo la posizione iniziale
posizione_x=0;
posizione_y=0;

%La distanza  definita dal comando, occorre discriminare la direzione, che
%comporta aggiungere/sottrarre la distanza richiesta a quella gi percorsa
for i=1:length(direzione)
    switch direzione(i) % ho 4 casi noti
        case 0
            posizione_x=posizione_x+metri(i);
        case 90
            posizione_y=posizione_y+metri(i);
        case 180
            posizione_x=posizione_x-metri(i);
        case 270
            posizione_y=posizione_y-metri(i);
    end
end

posizione=[posizione_x, posizione_y];

%% function visualizza(posizione)
% La funzione, assegnato il vettore posizione (2x1), restituisce a command
% window la distanza, in metri ed orientamento

function visualizza(posizione)

% Si discrimina l'orientamento valutando il segno della posizione

% Posizione sulla coordinata x
if(posizione(1)>=0) % Se positiva,  lungo est
    fprintf(1,'\n %g metri verso est \n',posizione(1));
else
    fprintf(1,'\n %g metri verso ovest \n',abs(posizione(1)));
end

%Posizione sulla coordinata y
if(posizione(2)>=0)  % Se positiva,  lungo nord
    fprintf(1,'\n %g metri verso nord \n',posizione(2));
else
    fprintf(1,'\n %g metri verso sud \n',abs(posizione(2)));
end

%% function casa=gohome(posizione) 
% La funzione determina i comandi per tornare alla posizione iniziale
% NB: Posizione iniziale (0,0)
% i comandi restituiti sono due, quindi l'uscita  una matrice (2x2)

function casa=gohome(posizione)

%Inizializzo la matrice in uscita
casa=zeros(2);

%Posizione sull'asse x (Direzioni est/ovest)
if (posizione(1)>=0)    %se positivo, verso est
    casa(1,1)= 180; % vado ad ovest (ovvero all'indietro)
else
    casa(1,1)=0;    % vado ad est (opposto di ovest)
end
casa(1,2)=abs(posizione(1)); % mi sposto della stessa distanza

%Posizione sull'asse y (Direzioni nord/sud)
if (posizione(2)>=0) % se positivo, il robot  a nord
    casa(2,1)=-90;  % nego la direzione, andando a sud
else
    casa(2,1)=90; %nego la direzione, andando a nord
end
casa(2,2)=abs(posizione(2)); %Spostamento di egual distanza


%%  function salvacomandi(comandi,nomefile)
% La funzione salva la matrice comandi (matrice con 2 colonne, numero di
% righe qualsiasi) nel file di testo, con nome 'nomefile'


function salvacomandi(comandi,nomefile)

%Non conosco a priori in numero di righe: recupero l'informazione con la
%size
[righe,colonne]=size(comandi);

fid=fopen(nomefile,'w'); %apro file di testo, in scrittura
for i=1:righe
    fprintf(fid,'%d\t%d\n',comandi(i,1),comandi(i,2));
end
fclose(fid); %chiudo file di testo

